package comms

import "git.wamblee.org/converge/pkg/testsupport"

func (s *AgentServerTestSuite) Test_clientIdPassedAsLocalAddr() {
	agentChannel, serverChannel := s.createCommChannel()

	clientId := "myid"
	testsupport.RunAndWait(
		&s.Suite,
		func() any {
			listener := NewAgentListener(agentChannel.Session)
			connection, err := listener.Accept()
			s.Nil(err)
			// clientId identifyable as local addr
			s.Equal(clientId, connection.LocalAddr().String())
			return nil
		},
		func() any {
			connection, err := serverChannel.Session.OpenStream()
			s.Nil(err)
			err = SendClientInfo(connection, ClientInfo{ClientId: clientId})
			s.Nil(err)
			return nil
		})
}
